----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:24:42 10/03/2012 
-- Design Name: 
-- Module Name:    btn_config - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.config.all; 

entity btn_config is
    Port ( clk          : in   STD_LOGIC;
           reset        : in   STD_LOGIC;
           sw_level     : in   STD_LOGIC;
           btn_tick     : in   STD_LOGIC;
           btn1_tick    : in   STD_LOGIC;
           btn2_tick    : in   STD_LOGIC;
           btn3_tick    : in   STD_LOGIC;
           count_fbgref : out  integer range 0 to MAX_FBGS;
           count_fbgsen : out  integer range 0 to MAX_FBGS;
           count_mean   : out  integer range 0 to 100;
           mean         : out  std_logic_vector(RAMP_BITS-1 downto 0);
           count        : out  integer range 0 to MAX_COUNT);
end btn_config;

architecture Behavioral of btn_config is

begin

fbg_ref_unit: entity work.fbg_config(behavioral)
    port map(clk => clk, reset => reset, sw => sw_level, btn => btn2_tick, count_fbg => count_fbgref); 
    
fbg_sen_unit: entity work.fbg_config(behavioral)
    port map(clk => clk, reset => reset, sw => sw_level, btn => btn3_tick, count_fbg => count_fbgsen); 
    
mean_dac_unit: entity work.mean_dac(behavioral)
    port map(clk => clk, reset => reset, btn => btn1_tick, sw => sw_level, mean => mean, count_mean => count_mean); 
    
freq_sel_unit: entity work.freq_sel(behavioral)
        port map (
            clk => clk, reset => reset, sw => sw_level, btn => btn_tick, count => count); 
            
end Behavioral;

